;; Copyright 2007, 2008, 2009, 2010, 2012 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

;;-----------------
(find-file "my-compilation.txt")

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (require 'compilation-perl)
  )
(require 'cl)

;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

;;-----------------
(let ((eval-expression-print-length nil)
      (eval-expression-print-level nil)
      (print-length nil)
      (print-level nil))
  (require 'compile)
  (switch-to-buffer "x")
  (pp compilation-error-regexp-alist-alist (current-buffer))
  (goto-char (point-min)))

(progn
  ;; (setq debug-on-error t)
  (define-key global-map [f4]  'next-error)
  (define-key global-map [f16] 'previous-error)
  (add-to-list 'load-path (expand-file-name ".."))

  (eval-after-load "compile" '(require 'compilation-perl))
  (compile "set -x;
            xsubpp d-compilation-perl.xs >/dev/null;
            echo '';
            echo '';
            podchecker d-compilation-perl.pod;
            echo '';
            perl d-compilation-perl-gtk.pl;
            echo '';
            perl d-compilation-perl-more.t;
            echo '';
            perl \"-MExtUtils::Command::MM\" \"-e\" \"test_harness(0)\" d-compilation-perl-more.t;
            echo '';
            perl d-compilation-perl.t;
            echo '';
            perl \"-MExtUtils::Command::MM\" \"-e\" \"test_harness(0)\" d-compilation-perl-2.t;
")
  (switch-to-buffer "*compilation*")
  (font-lock-mode 1))

;;-----------------

(with-temp-buffer
(progn
  (kill-buffer "*compilation-perl.el temp*")
  (with-current-buffer (get-buffer-create "*compilation-perl.el temp*")
    (insert "\n\n(in cleanup) something bad at foo.pl line 3 during global destruction.")
    (compilation-mode)

    '(condition-case nil
         (identity t)
       (error nil))
    (compilation-buffer-p (current-buffer))
    ;; (progn (compilation-next-error 1 nil (point-min)) t)
    (goto-char (point-min))
    (next-single-property-change (point) 'message)
    compilation-locs
    (point)))

(progn
  (let ((foo-bar-quux 1))
    (intern-soft "foo-bar-quux"))
  (garbage-collect)
  (intern-soft "foo-bar-quux"))

;;-----------------

(setq compilation-error-regexp-alist-alist
      (remove (assoc 'compilation-perl--Test::Builder-name
                     compilation-error-regexp-alist-alist)
              compilation-error-regexp-alist-alist))
(setq compilation-error-regexp-alist-alist
      (remove (assoc 'compilation-perl--Test::Builder-noname
                     compilation-error-regexp-alist-alist)
              compilation-error-regexp-alist-alist))

../compilation-perl.el

(progn
 (setq compilation-error-regexp-alist-alist
  (remove (assoc 'compilation-perl--Glib::Log
                     compilation-error-regexp-alist-alist)
              compilation-error-regexp-alist-alist))

 (add-to-list 'compilation-error-regexp-alist-alist
              '(compilation-perl--Glib::Log "^GLib-GObject-WARNING **:.*at \\([^ \n]+\\) line \\([0-9]+\\)\\( during global destruction\\)?\\.$")
              t))

(let ((str "GLib-GObject-WARNING **: /build/buildd/glib2.0-2.14.5/gobject/gsignal.c:1741: instance `0x8206790' has no handler with id `1234' at d-compilation-perl-gtk.pl line 3.")
      found)
  (require 'compile)
  (mapc (lambda (elem)
          (let ((regexp (cadr elem)))
            (when (string-match regexp str)
              (message "%s" (car elem))
              (add-to-list 'found (car elem)))))
        compilation-error-regexp-alist-alist)
  found)

(let ((str "GLib-GObject-WARNING **: /build/buildd/glib2.0-2.14.5/gobject/gsignal.c:1741: instance `0x8206790' has no handler with id `1234' at d-compilation-perl-gtk.pl line 3.")
      (regexp "^\\(?:[[:alpha:]][-[:alnum:].]+: ?\\)?\
\\([0-9]*[^0-9\n]\\(?:[^\n ]\\| [^-\n]\\)*?\\): ?\
\\([0-9]+\\)\\(?:\\([.:]\\)\\([0-9]+\\)\\)?\
\\(?:-\\([0-9]+\\)?\\(?:\\3\\([0-9]+\\)\\)?\\)?:\
\\(?: *\\(\\(?:Future\\|Runtime\\)?[Ww]arning\\|W:\\)\\|\
 *\\([Ii]nfo\\(?:\\>\\|rmationa?l?\\)\\|I:\\|instantiated from\\|[Nn]ote\\)\\|\
\[0-9]?\\(?:[^0-9\n]\\|$\\)\\|[0-9][0-9][0-9]\\)"))
  (string-match regexp str))



;;-----------------

(progn
  (require 'autoload)
  (find-file "/tmp/x.el")
  (erase-buffer)
  (generate-file-autoloads "../compilation-perl.el")
  (save-buffer)
  (byte-compile-file (buffer-file-name))
  (delete-file (concat (buffer-file-name) "c"))
  (delete-file (buffer-file-name)))


;;-----------------

(looking-at "# Failed test [0-9]+ in \\([^ \t\r\n]+\\) at line \\([0-9]+\\)")
# Failed test 1 in d-compilation-perl.t at line 5

(re-search-forward "NOK.*? \\([^ \t\r\n]+\\) at line \\([0-9]+\\)")
d-compilation-perl....
                                                                             
d-compilation-perl....NOK 1# Failed test 1 in d-compilation-perl.t at line 5


(let ((n 0))
  (require 'compile)
  (dolist (elem compilation-error-regexp-alist)
    (setq n (1+ n))
    (if (looking-at (car elem))
	(message "match: %s  %s" n elem)))
  (switch-to-buffer (or (get-buffer "*Messages*")
			(get-buffer " *Message-Log*"))))
# Failed test 1 in d-compilation-perl.t at line 5


(let ((n 0))
  (require 'compile)
  (dolist (elem compilation-error-regexp-alist)
    (setq n (1+ n))
    (if (save-excursion (re-search-forward (car elem) nil t))
	(message "match: %s  %s\n%s" n elem (match-string 0))))
  (switch-to-buffer (or (get-buffer "*Messages*")
			(get-buffer " *Message-Log*"))))
d-compilation-perl-2....
                                                                             
d-compilation-perl-2....NOK 1# Failed test 1 in d-compilation-perl-2.t at line 8



(defadvice read (around my-perldoc-noswitch activate)
  "Don't switch to the new buffer."
  (message "%s" stream)
  ad-do-it)
(debug-on-entry 'load)
(require 'compile)


(defun my-which-match ()
  (interactive)
  (let (ret)
    (dolist (elem compilation-error-regexp-alist-alist)
      (let ((symbol (car elem))
	    (regexp (cadr elem)))
	(if (looking-at regexp)
	    (add-to-list 'ret symbol))))
    ret))

(setq compilation-error-regexp-alist '(cucumber))

# Current time local: Wed Aug 15 12:04:58 2012

(looking-at "^\\(.+?\\)\\(:[ 	]*\\)\\([1-9][0-9]*\\)\\2")
Grep started at Wed Aug  8 14:42:26
