;; Copyright 2009, 2010, 2011, 2015 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;    perl -e '{use open IN=>\":via(gzip)\";require shift}' gunzip-data.pl.gz

(progn
  (find-file "/doc/prima/examples/amba.gz")
  (compile-command-default-perl-interpreter))

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (require 'compile-command-default))

(progn
  (find-file "/usr/bin/checklink")
  (compile-command-default-perl-interpreter))


(progn
  (find-file "/tmp/x.pl")
  (compile-command-default-perl-pl))

(progn
  (find-file "/tmp/dist/t/foo.t")
  (compile-command-default-perl-t-harness))
(progn
  (find-file "/tmp/t/abc/def.t")
  (compile-command-default-perl-t-harness))

(progn
  (find-file "/tmp/t/abc/def.t")
  (compile-command-default-perl-t-raw))
(progn
  (find-file "/tmp/examples/foo.pl")
  (compile-command-default-perl-t-raw))
(progn
  (find-file "/tmp/devel/foo.pl")
  (compile-command-default-perl-t-raw))
(progn
  (find-file "/tmp/not/foo.t")
  (compile-command-default-perl-t-raw))
(progn
  (find-file "/tmp/adevel/foo.pl")
  (compile-command-default-perl-t-raw))




;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

;;-----------------------------------------------------------------------------

(let ((filename    (concat default-directory "/../compile-command-default.el"))
      (tempfile    "/tmp/x.el")
      (print-level nil))
  (require 'autoload)
  (find-file tempfile)
  (erase-buffer)
  (generate-file-autoloads filename)
  (save-buffer)
  (byte-compile-file tempfile)
  (delete-file (concat tempfile "c"))
  (delete-file tempfile))

;;-----------------------------------------------------------------------------
;; compile-command-default--interpreter

(progn
  (byte-compile 'compile-command-default--interpreter)
  (disassemble 'compile-command-default--interpreter))

;; linux kernel allows multiple spaces, but that's not used
;; grep "^#[!][ \t][ \t]" /bin/* /usr/bin/*

