;; Copyright 2008, 2009, 2010 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

               ,(concat "\\`\\(" (string  222  18  4  149)
                        "\\|"    (string  149  4  18  222) "\\)")

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (autoload 'mo-mode "mo-mode" nil t)
  (modify-coding-system-alist 'file "\\.g?mo\\'" 'raw-text-unix)
  (add-to-list 'auto-mode-alist '("\\.g?mo\\'" . mo-mode))

  (find-file "/tmp/x.mo"))

(progn
  (if (featurep 'xemacs)
      (require 'un-define))

  ;; us-ascii
  (find-file "/usr/share/locale/en_GB/LC_MESSAGES/libc.mo")

  ;; iso-8859-1
  (find-file "/usr/share/locale/fr/LC_MESSAGES/libc.mo")

  ;; iso-8859-7
  (find-file "/usr/share/locale/el/LC_MESSAGES/libc.mo")

  ;; euc-jp
  (find-file "/usr/share/locale/ja/LC_MESSAGES/libc.mo")

  ;; utf-8
  (find-file "/usr/share/locale/fr/LC_MESSAGES/gtk20.mo")

  )


(find-file "../test/mo-ascii.gmo")
(find-file "../test/mo-utf8.gmo")
(find-file "../test/mo-nocontent.mo")
(find-file "../test/mo-badcharset.mo")


(setq debug-on-error t)
(fmakunbound 'po-mode)
(fboundp 'po-mode)


(progn
  (setq load-path (remove "/usr/share/emacs/21.4/site-lisp/gettext" load-path))
  (setq load-path (remove "/usr/share/emacs/site-lisp/gettext"      load-path)))

(let ((tempfile "/tmp/x.el")
      (print-level nil))
  (require 'autoload)
  (find-file tempfile)
  (erase-buffer)
  (generate-file-autoloads "../mo-mode.el")
  (save-buffer)
  (byte-compile-file tempfile)
  (delete-file (concat tempfile "c"))
  (delete-file tempfile))


(switch-to-buffer "x")
(let ((coding-system-for-read 'raw-text-unix))
  (call-process "msgunfmt"
                ...
                "/home/gg/lisp/test/mo-utf8.gmo")
;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

