;; Copyright 2007, 2008, 2009, 2010 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;; Run info-xref.el over the emacs or gnus manuals.


;;-----------------------------------------------------------------------------
;; emacs cvs

(progn
  (require 'info-xref)

  ;; (shell-command "ln -sf /down/texinfo/texinfo/doc/texinfo /down/texinfo/texinfo/doc/texinfo-* /down/emacs/info")
  ;; (shell-command "ln -sf /down/texinfo/texinfo/doc/info-stnd.info /down/texinfo/texinfo/doc/info-stnd.info-* /down/emacs/info")

  (shell-command "ln -sf /usr/share/xemacs21/xemacs-packages/info/auctex.info.gz /down/emacs/info")
  (shell-command "ln -sf /usr/share/xemacs21/xemacs-packages/info/bbdb.info.gz /down/emacs/info")
  ;; (shell-command "ln -sf /usr/share/xemacs21/xemacs-packages/info/sasl.info.gz /down/emacs/info")

  ;; (shell-command "ln -sf /usr/share/info/automake-1.10.info.gz /down/emacs/info/automake.info.gz")
  ;; (shell-command "ln -sf /usr/share/info/automake-1.10.info-*.gz /down/emacs/info")

  (shell-command "ln -sf /down/autoconf/doc/autoconf.info* /down/emacs/info")

  (info-initialize)
  (setq Info-directory-list '("/down/emacs/info" "/usr/share/info")))

(let ((lst (directory-files "/down/emacs/info" t)))
  (require 'cl)
  (setq lst (remove* "\\.\\'" lst :test 'string-match))
  (setq lst (remove* "/\\." lst :test 'string-match))
  (setq lst (remove* "/COPYING\\'" lst :test 'string-match))
  (setq lst (remove* "/CVS\\'" lst :test 'string-match))
  (setq lst (remove* "\\.gz\\'" lst :test 'string-match))
  (setq lst (remove* "auctex" lst :test 'string-match))
  (setq lst (remove* "bbdb" lst :test 'string-match))
  (setq lst (remove* "autoconf" lst :test 'string-match))
  (setq lst (remove* "automake" lst :test 'string-match))
  (dolist (i lst)
    (setq lst (remove* (concat (regexp-quote i) "-[0-9]+\\'") lst
                       :test 'string-match)))

  (info-xref-check-list lst))


;;-----------------------------------------------------------------------------
;; gnus cvs

(progn
  (require 'info-xref)
  (info-initialize)
  (setq Info-directory-list
        '("/down/ding/gnus/texi" "/down/emacs/info" "/usr/share/info"))
  (info-xref-check-list
   (list "/down/ding/gnus/texi/auth"
         "/down/ding/gnus/texi/emacs-mime"
         "/down/ding/gnus/texi/gnus"
         "/down/ding/gnus/texi/message"
         "/down/ding/gnus/texi/pgg"
         "/down/ding/gnus/texi/sasl"
         "/down/ding/gnus/texi/sieve")))
;; "/down/ding/gnus/texi/gnus-faq.info"


;;-----------------------------------------------------------------------------
;; cc-mode cvs
(progn
  (require 'info-xref)
  (info-initialize)
  (setq Info-directory-list
        '("/down/emacs/info" "/usr/share/info"))

  (info-xref-with-output
   (info-xref-check-list
    (list "/down/cc-mode/cc-mode.info"))
   (info-xref-check-list
    (list "/down/cc-mode/cc-mode.info"))))



;;-----------------------------------------------------------------------------

(defun my-info-directory (dir)
  "Setup an extra info directory.
This is added to `Info-directory-list' if info has been initialized, or
to `Info-default-directory-list' if not.

`Info-additional-directory-list' is not used, since that comes after
`Info-directory-list' in the searching, and extras should come before the
standard locations."

  (when (file-exists-p dir)
    (add-to-list (if (boundp 'Info-directory-list) ;; when loaded
                     'Info-directory-list
                   'Info-default-directory-list)
                 dir)))

;; (add-to-list 'same-window-buffer-names "*info*")
(setq same-window-regexps nil)

;; Info-directory-list

;; (progn
;;   (require 'info-xref)
;;   (info-initialize)
;;   (info-xref-check-all-custom)
;;   )


;;  (list "/down/emacs/info/ada-mode"
;;        "/down/emacs/info/autotype"
;;        "/down/emacs/info/calc"
;;        "/down/emacs/info/ccmode"
;;        "/down/emacs/info/cl"
;;        "/down/emacs/info/dbus"
;;        "/down/emacs/info/dired-x"
;;        "/down/emacs/info/ebrowse"
;;        "/down/emacs/info/ediff"
;;        "/down/emacs/info/efaq"
;;        "/down/emacs/info/eintr"
;;        "/down/emacs/info/elisp"
;;        "/down/emacs/info/emacs"
;;        "/down/emacs/info/emacs-mime"
;;        "/down/emacs/info/epa"
;;        "/down/emacs/info/erc"
;;        "/down/emacs/info/eshell"
;;        "/down/emacs/info/eudc"
;;        "/down/emacs/info/flymake"
;;        "/down/emacs/info/forms"
;;        "/down/emacs/info/gnus"
;;        "/down/emacs/info/idlwave"
;;        "/down/emacs/info/info"
;;        "/down/emacs/info/message"
;;        "/down/emacs/info/mh-e"
;;        "/down/emacs/info/newsticker"
;;        "/down/emacs/info/nxml-mode"
;;        "/down/emacs/info/org"
;;        "/down/emacs/info/pcl-cvs"
;;        "/down/emacs/info/pgg"
;;        "/down/emacs/info/rcirc"
;;        "/down/emacs/info/reftex"
;;        "/down/emacs/info/remember"
;;        "/down/emacs/info/sc"
;;        "/down/emacs/info/ses"
;;        "/down/emacs/info/sieve"
;;        "/down/emacs/info/smtpmail"
;;        "/down/emacs/info/speedbar"
;;        "/down/emacs/info/tramp"
;;        "/down/emacs/info/url"
;;        "/down/emacs/info/vip"
;;        "/down/emacs/info/viper"
;;        "/down/emacs/info/widget"
;;        "/down/emacs/info/woman")
