;; Copyright 2009, 2010 Kevin Ryde

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

(add-to-list 'load-path (expand-file-name ".."))

(defun my-run-test ()
  (require 'miscbits-el-loaddefs)
  (let ((count 0))

    ;; with bytecomp-simplify.el loaded before bytecomp.el
    (require 'bytecomp-simplify)
    (require 'bytecomp)

    ;; no leftovers in emacs21 byte compiling defadvice
    (when (and (boundp 'byte-compile-unresolved-functions)
               byte-compile-unresolved-functions)
      (error "byte-compile-unresolved-functions after load: %S"
             byte-compile-unresolved-functions))
    (setq count (1+ count))


    ;;-------------------------------------------------------------------------
    ;; byte-compile-warnings custom

    (let ((type (get 'byte-compile-warnings 'custom-type)))
      (when (eq 'choice (car-safe type))
        (let ((set (assq 'set type)))
          (when set
            (unless (member '(const simplify) set)
              (error "`byte-compile-warnings' not extended:\n%S" type))
            (setq count (1+ count))))))

    ;;-------------------------------------------------------------------------
    (message "  %d tests" count)
    count))
