;; Copyright 2009, 2010, 2013 Kevin Ryde

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


(add-to-list 'load-path (expand-file-name ".."))

(defun my-run-test ()
  (require 'ffap-gcc-path)
  (let ((count 0))

    ;;-------------------------------------------------------------------------
    ;; check works with non-existent current directory

    (let ((default-directory "/no/such/dir/"))
      (ffap-gcc-path-setup)

      (or (equal default-directory "/no/such/dir/")
          (error "oops, default-directory changed"))
      ffap-c-path
      (setq count (1+ count)))

    ;; check doesn't error out for no gcc
    (message "Expected error \"nosuchprogramexists\" here ...")
    (let ((ffap-gcc-program "/usr/bin/nosuchprogramexists"))
      (ffap-gcc-path-setup)
      (setq count (1+ count))
      ffap-c-path)

    ;;-------------------------------------------------------------------------
    ;; unload-feature

    (unload-feature 'ffap-gcc-path t)
    (setq count (1+ count))

    ;;-------------------------------------------------------------------------

    (message "  %d tests" count)
    count))



;; unused:
;;
;; (defun my-gcc-exists-p (ffap-gcc-program)
;;   (condition-case nil
;;       (equal 0 (call-process "gcc" nil nil nil "--version"))
;;     (error nil)))

