;; Copyright 2010 Kevin Ryde

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

(add-to-list 'load-path (expand-file-name ".."))

(defconst my-perl-available-p
  (condition-case nil
      (equal 0 (call-process "perl"
                             nil  ;; stdin
                             nil  ;; stdout
                             nil  ;; display
                             "--version"))
    (error nil))
  "Non-nil if the \"perl\" program is available.")

(defun my-run-test ()
  (require 'miscbits-el-loaddefs)
  (let ((count 0))

    ;;-------------------------------------------------------------------------
    ;; autoloads

    (mapcar (lambda (func)
              (unless (fboundp func)
                (error "`%S' not autoloaded" func))
              (setq count (1+ count)))
            '(pst-format-decode
              pst-format-encode))

    (mapcar (lambda (symbol)
              (unless (memq t
                            (mapcar (lambda (elem)
                                      (and (eq symbol (car-safe elem))
                                           (progn
                                             (mapcar (lambda (func)
                                                       (unless (fboundp func)
                                                         (error "`%S' not autoloaded" func)))
                                                     (list (nth 3 elem)
                                                           (nth 4 elem)))
                                             t)))
                                    format-alist))
                (error "`%S' not autoloaded in `format-alist'" symbol))
              (setq count (1+ count)))
            '(pst-format))

    ;;-------------------------------------------------------------------------
    ;; unload-feature

    (require 'pst-format)

    (unload-feature 'pst-format t)


    ;;-------------------------------------------------------------------------

    (message "  %d tests" count)
    count))
