;; Copyright 2009, 2010, 2014 Kevin Ryde

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


(defun my-run-test ()
  (let* ((srcdir          (expand-file-name ".."))
         (readme-filename (expand-file-name "README" srcdir))
         (file-list       (directory-files srcdir
                                           nil ;; relative filenames
                                           "\\`[^.].*\\.el\\'"
                                           ))  ;; sorted
         (count           0)
         (notfound        0))

    (dolist (filename '("miscbits-byte-compile.el"
                        "miscbits-el-finder-inf.el"
                        "miscbits-generate-loaddefs.el"
                        "miscbits-generate-finder.el"))
      (setq file-list (remove filename file-list)))

    (message "srcdir %S has %d .el files" srcdir (length file-list))
    (when (null file-list)
      (error "Oops, no *.el files"))

    (unless (file-exists-p readme-filename)
      (error "no such file %S" readme-filename))
    (find-file readme-filename)

    (dolist (filename file-list)
      (goto-char (point-min))
      (unless (re-search-forward (concat "^[ \t]*" (regexp-quote filename)
                                         "\\>")
                                 nil t)
        (message "README doesn't mention %S" filename)
        (setq notfound (1+ notfound)))
      (setq count (1+ count)))

    (unless (zerop notfound)
      (error "  %s not in README" notfound))

    (message "  %d tests" count)
    count))
